#include <iostream>
#include <vector>

using namespace std;

struct 
Input {
    vector<double> numbers;
    int bin_count{};
};

Input 
input_data(){
    size_t number_count;
    cin >> number_count;
    Input in;
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }
    int bin_count;
    cin >> in.bin_count;
    return in;
}

void
find_minmax(const std::vector<double> &numbers, double &min, double &max){
    min = numbers[0];
    max = numbers[0];
    for (double x : numbers)
    {
        if (x < min)
        {
            min = x;
        }
        else if (x > max)
        {
            max = x;
        }
    }

}

std::vector<int>
make_histogram(std::vector<double> numbers, size_t bin_count){
    double min;
    double max;
    vector<int> bins(bin_count);
    find_minmax(numbers, min, max);
    double bin_size = (max - min) / bin_count;
    for (size_t i = 0; i < numbers.size(); i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }

        }
        if (!found)
            {
                bins[bin_count - 1]++;
            }
    }
    return bins;
}

int 
main()
{
    
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);

    double min;
    double max;
    find_minmax(in.numbers, min, max);
    
    size_t max_count;
    for (int i =0; i<in.bin_count;i++){
        if (in.numbers[i]>max_count){
            max_count=in.numbers[i];
        }
    }
   

    for (int i =0; i<in.bin_count;i++){
        if (bins[i]>max_count){
            max_count=bins[i];
        }
    }

    //*cout<<max_count<<endl;

    if (max_count>MAX_ASTERISK){
        for (int i=0; i<in.bin_count; i++){
            size_t height = MAX_ASTERISK * (static_cast<double>(bins[i]) / max_count);
            if (bins[i]<10){
                cout<<"  "<<bins[i]<<"|";
                for (int j=0;j<bins[i];j++){
                    cout<<"*";
                }
                cout<<endl;
            }
            else if(bins[i]<100){
               cout<<" "<<bins[i]<<"|";
                for (int j=0;j<bins[i];j++){
                    cout<<"*";
                }
                cout<<endl;
            }
            else{
                cout<<bins[i]<<"|";
                for (int j=0;j<bins[i];j++){
                    cout<<"*";
                }
                cout<<endl;
            }

        }
    }else{
        for (int i=0; i<in.bin_count; i++){
            if (bins[i]<10){
                cout<<"  "<<bins[i]<<"|";
                for (int j=0;j<bins[i];j++){
                    cout<<"*";
                }
                cout<<endl;
            }
            else if(bins[i]<100){
               cout<<" "<<bins[i]<<"|";
                for (int j=0;j<bins[i];j++){
                    cout<<"*";
                }
                cout<<endl;
            }
            else{
                cout<<bins[i]<<"|";
                for (int j=0;j<bins[i];j++){
                    cout<<"*";
                }
                cout<<endl;
            }

        }
    }
    for (int i =0; i< in.bin_count;i++){
        cout<<bins[i]<<" ";
    }
}
 
   